/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __houdini_HoudiniDraw_h__
#define __houdini_HoudiniDraw_h__

namespace fe
{

/**************************************************************************//**
    @brief Draw to Houdini

	@ingroup houdini
*//***************************************************************************/
class FE_DL_EXPORT HoudiniDraw: public DrawCommon
{
	public:
					HoudiniDraw(void): m_pGdp(NULL)							{}
virtual				~HoudiniDraw(void)										{}

					//* as DrawI
virtual void		drawPoints(const SpatialVector *vertex,
							const SpatialVector *normal,U32 vertices,
							BWORD multicolor,const Color *color);

virtual	void		drawLines(const SpatialVector *vertex,
							const SpatialVector *normal,U32 vertices,
							StripMode strip,BWORD multicolor,
							const Color *color);
virtual void		drawTriangles(const SpatialVector *vertex,
							const SpatialVector *normal,
							const Vector2f *texture,U32 vertices,
							StripMode strip,BWORD multicolor,
							const Color* color);

					//* Houdini specific

		void		setGdp(GU_Detail* a_pGdp)	{ m_pGdp=a_pGdp; }
		GU_Detail*	gdp(void)					{ return m_pGdp; }

	private:
		void		drawPolygons(const SpatialVector *vertex,
							const SpatialVector *normal,U32 vertices,
							StripMode strip,BWORD multicolor,
							const Color *color,BWORD openPoly);

		GU_Detail*	m_pGdp;
};

} // namespace

#endif /* __houdini_HoudiniDraw_h__ */
