import os
import sys
import string
forge = sys.modules["forge"]

def setup(module):
	# the library
	srclist = [	"network.pmh",
				"Chunk",
				"ChunkSender",
				"ChunkReceiver",
				"Client",
				"Listener",
				"Server",
				"SignalReceiver",
				"SignalSender",
				"Socket",
				"SocketHandler",
				"networkLib"
				]

	if forge.filesystem:
		srclist += [
				"MultiGroupReader",
				"MultiGroupWriter",
				]

	forge.objlists['network'] = module.SrcToObj(srclist);

	lib = module.Lib("fexNetwork",srclist)

	liblist = [	"fePlatformLib",
				"feMemoryLib",
				"feCoreLib",
				"fePluginLib",
				"feSignalLib",
				"fexNetworkLib",
				"fexDataToolDLLib",
				"feDataLib"
				]


	# the plugin
	dlsrclist = [
		"networkDL"
		]

	dll = module.DLL( "fexNetworkDL", dlsrclist)
	forge.deps( ["fexNetworkDLLib"], liblist )
	dll.AddDep(lib)

	forge.tests += [
		("inspect.exe",		"fexNetworkDL",					None,		None) ]

	module.Module('test')

	module.Image("network")
	module.Image("netstack")
	module.Image("network_overview")


