import os
import sys
forge = sys.modules["forge"]

def setup(module):
	srcList = [	"oplab.pmh",
				"BindEditOp",
				"CurvaceousOp",
				"FusionOp",
				"GridWrapOp",
				"NexusOp",
				"RecordOp",
				"SurfaceViewerOp",
				"XRayOp",
				"oplabDL" ]

	dll = module.DLL( "fexOpLabDL", srcList )

	deplibs = forge.corelibs+ [
				"fexMathLib",
				"fexOperateDLLib",
				"fexSurfaceDLLib",
				"fexWindowLib"	]

	if 'graphviz' in forge.module_list and os.path.exists('ext/graphviz') and os.path.exists('/usr/include/graphviz/gvc.h'):
		module.cppmap = {}
		module.cppmap['meta'] = ' -DFE_USE_GRAPHVIZ'
	else:
		forge.color_on(0, forge.BLUE)
		sys.stdout.write("-graphviz ")
		forge.color_off()

	if 'viewer' in forge.module_list and os.path.exists('ext/viewer'):
		deplibs += [ "fexViewerLib" ]
	else:
		forge.color_on(0, forge.BLUE)
		sys.stdout.write("-viewer ")
		forge.color_off()

	forge.deps( ["fexOpLabDLLib"], deplibs )

	forge.tests += [
		("inspect.exe",	"fexOpLabDL",					None,	None) ]

